from z3 import *;

#ADCTF_XXXXXXXXXXXXXXXXXXXX
flag = BitVecs('a b c d e f g h i j k l m n o p q r s t u v w x y z', 32)
bv = flag[:]

"""
s.add(tonum('bytwycju') + tonum('yzvyjjdy') ^ tonum('vugljtyn') + tonum('ugdztnwv') | tonum('xbfziozy') == tonum('bzuwtwol'))
    ^         ^          ^          ^          ^
s.add(tonum('wwnnnqbw') - tonum('uclfqvdu') & tonum('oncycbxh') | tonum('oqcnwbsd') ^ tonum('cgyoyfjg') == tonum('vyhyjivb'))
    &         &          &          &          &
s.add(tonum('yzdgotby') | tonum('oigsjgoj') | tonum('ttligxut') - tonum('dhcqxtfw') & tonum('szblgodf') == tonum('sfgsoxdd'))
    +         +          +          +          +
s.add(tonum('yjjowdqh') & tonum('niiqztgs') + tonum('ctvtwysu') & tonum('diffhlnl') - tonum('thhwohwn') == tonum('xsvuojtx'))
    -         -           -         -          -
s.add(tonum('nttuhlnq') ^ tonum('oqbctlzh') - tonum('nshtztns') ^ tonum('htwizvwi') + tonum('udluvhcz') == tonum('syhjizjq'))
    =         =           =         =          =         
s.add(tonum('fjivucti')   tonum('zoljwdfl')   tonum('sugvqgww')   tonum('uxztiywn')   tonum('jqxizzxq'))
"""


"""

s.add(tonum('bytwycju') + tonum('yzvyjjdy', ^ tonum('vugljtyn', + tonum('ugdztnwv', | tonum('xbfziozy', == tonum('bzuwtwol'))
s.add(tonum('wwnnnqbw') - tonum('uclfqvdu', & tonum('oncycbxh', | tonum('oqcnwbsd', ^ tonum('cgyoyfjg', == tonum('vyhyjivb'))
s.add(tonum('yzdgotby') | tonum('oigsjgoj', | tonum('ttligxut', - tonum('dhcqxtfw', & tonum('szblgodf', == tonum('sfgsoxdd'))
s.add(tonum('yjjowdqh') & tonum('niiqztgs', + tonum('ctvtwysu', & tonum('diffhlnl', - tonum('thhwohwn', == tonum('xsvuojtx'))
s.add(tonum('nttuhlnq') ^ tonum('oqbctlzh', - tonum('nshtztns', ^ tonum('htwizvwi', + tonum('udluvhcz', == tonum('syhjizjq'))
s.add(tonum('fjivucti')   tonum('zoljwdfl',   tonum('sugvqgww',   tonum('uxztiywn',   tonum('jqxizzxq',)
"""

def ch2idx(ch):
    return ord(ch)-ord('a')

def tonum(val):
    r = 0;
    for i in val:
        idx = ch2idx(i)
        r = r*10 + flag[idx];
    return r;

s = Solver()

for i in xrange(26):
    s.add( UGE(flag[i],  0L) and ULE(flag[i], 9L) )


s.add(tonum('bytwycju') + tonum('yzvyjjdy') ^ tonum('vugljtyn') + tonum('ugdztnwv') | tonum('xbfziozy') == tonum('bzuwtwol'))
s.add(tonum('wwnnnqbw') - tonum('uclfqvdu') & tonum('oncycbxh') | tonum('oqcnwbsd') ^ tonum('cgyoyfjg') == tonum('vyhyjivb'))
s.add(tonum('yzdgotby') | tonum('oigsjgoj') | tonum('ttligxut') - tonum('dhcqxtfw') & tonum('szblgodf') == tonum('sfgsoxdd'))
s.add(tonum('yjjowdqh') & tonum('niiqztgs') + tonum('ctvtwysu') & tonum('diffhlnl') - tonum('thhwohwn') == tonum('xsvuojtx'))
s.add(tonum('nttuhlnq') ^ tonum('oqbctlzh') - tonum('nshtztns') ^ tonum('htwizvwi') + tonum('udluvhcz') == tonum('syhjizjq'))
s.add(tonum('q') != 0)
s.add(tonum('a') != 2)

def add_column(aa,bb,cc,dd,ee,ff):
 global s
 s.add(tonum(aa) ^ tonum(bb) & tonum(cc) + tonum(dd) - tonum(ee) == tonum(ff))


add_column('bytwycju', 'wwnnnqbw', 'yzdgotby', 'yjjowdqh', 'nttuhlnq', 'fjivucti')
add_column('yzvyjjdy', 'uclfqvdu', 'oigsjgoj', 'niiqztgs', 'oqbctlzh', 'zoljwdfl')
add_column('vugljtyn', 'oncycbxh', 'ttligxut', 'ctvtwysu', 'nshtztns', 'sugvqgww') 
add_column('ugdztnwv', 'oqcnwbsd', 'dhcqxtfw', 'diffhlnl', 'htwizvwi', 'uxztiywn')
add_column( 'xbfziozy', 'cgyoyfjg', 'szblgodf', 'thhwohwn', 'udluvhcz', 'jqxizzxq')

    
if s.check() == sat:
    m = s.model()
    print [ ( m[x].as_long() ) for x in bv ]
else:
    print "nosat"
